
/**
 * Make the counter work
 */
public class Driver
{
    public static void main( String args[] )
    {
        // We need a counter
        Counter c = new Counter();

        // We want to increment counter to 20 by using two
        // separate threads
        Accessor one = new Accessor( "one", c );
        Accessor two = new Accessor( "two", c );

        // Start the threads
        one.start();
        two.start();
        System.out.println("Be patient --- this takes a while to run.");
        try
        {
            // Wait for each thread to finish
            one.join();
            two.join();
            // Write out the result
            System.out.println( "The counter's value is " + c.get()
                    + ", the expected value is 20" );
        }
        catch( InterruptedException ie )
        {
            System.err.println( "Error during join" );
        }
    }
}
